/*	$NetBSD$	*/
/*-
 * Copyright (c) 2010 SHIMIZU Ryo <ryo@nerv.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _ARM_IMX_IMX51REG_H_
#define _ARM_IMX_IMX51REG_H_


#define IMX51_BOOTROM_BASE	0x00000000
# define IMX51_BOOTROM_SIZE		0x9000

#define IMX51_SCCRAM_BASE	0x1ffe0000
# define IMX51_SCCRAM_SIZE		0x00020000

#define IMX51_GPUMEM_BASE	0x20000000
# define IMX51_GPUMEM_SIZE		0x00020000
#define IMX51_GPU_BASE		0x30000000
# define IMX51_GPU_SIZE			0x10000000

#define IMX51_IPUEX_BASE	0x40000000
# define IMX51_IPUEX_SIZE		0x20000000
#define IMX51_ESDHC1_BASE	0x70004000
# define IMX51_ESDHC1_SIZE		0x4000
#define IMX51_ESDHC2_BASE	0x70008000
# define IMX51_ESDHC2_SIZE		0x4000

#define IMX51_UART0_BASE	0x73fbc000
#define IMX51_UART0_BASE_VADDR	0xf3fbc000
#define IMX51_UART1_BASE	0x73fc0000
#define IMX51_UART1_BASE_VADDR	0xf3fc0000
#define IMX51_UART2_BASE	0x7000c000
#define IMX51_UART2_BASE_VADDR	0xf000c000
# define IMX51_UART_SIZE		0x0100


#define IMX51_ECSPI1_BASE	0x70010000
# define IMX51_ECSPI1_SIZE		0x4000
#define IMX51_SSI2_BASE		0x70014000
# define IMX51_SSI2_SIZE		0x4000
#define IMX51_SDMA_REG_BASE	0x7001c000
# define IMX51_SDMA_REG_SIZE		0x4000
#define IMX51_ESDHC3_BASE	0x70020000
# define IMX51_ESDHC3_SIZE		0x4000
#define IMX51_ESDHC4_BASE	0x70024000
# define IMX51_ESDHC4_SIZE		0x4000
#define IMX51_SPDIF_BASE	0x70028000
# define IMX51_SPDIF_SIZE		0x4000
#define IMX51_PATA_UDMA_BASE	0x70030000
# define IMX51_PATA_UDMA_SIZE		0x4000
#define IMX51_USBOH3_BASE	0x73f80000
# define IMX51_USBOH3_SIZE		0x4000
#define IMX51_GPIO1_BASE	0x73f84000
# define IMX51_GPIO1_SIZE		0x4000
#define IMX51_GPIO2_BASE	0x73f88000
# define IMX51_GPIO2_SIZE		0x4000
#define IMX51_GPIO3_BASE	0x73f8c000
# define IMX51_GPIO3_SIZE		0x4000
#define IMX51_GPIO4_BASE	0x73f90000
# define IMX51_GPIO4_SIZE		0x4000
#define IMX51_KPP_BASE		0x73f94000
# define IMX51_KPP_SIZE			0x4000
#define IMX51_WDOG1_BASE	0x73f98000
# define IMX51_WDOG1_SIZE		0x4000
#define IMX51_WDOG2_BASE	0x73f9c000
# define IMX51_WDOG2_SIZE		0x4000
#define IMX51_GPT_BASE		0x73fa0000
# define IMX51_GPT_SIZE			0x4000
#define IMX51_SRTC_BASE		0x73fa4000
# define IMX51_SRTC_SIZE		0x4000
#define IMX51_IOMUXC_BASE	0x73fa8000
# define IMX51_IOMUXC_SIZE		0x4000

#define IMX51_EPIT1_BASE	0x73fac000
#define IMX51_EPIT2_BASE	0x73fb0000
# define IMX51_EPIT_SIZE		0x0014

#define IMX51_PWM1_BASE		0x73fb4000
# define IMX51_PWM1_SIZE		0x4000
#define IMX51_PWM2_BASE		0x73fb8000
# define IMX51_PWM2_SIZE		0x4000

#define IMX51_SRC_BASE		0x73fd0000
# define IMX51_SRC_SIZE			0x4000
#define IMX51_DPLLIP1_BASE	0x83f80000
# define IMX51_DPLLIP1_SIZE		0x4000
#define IMX51_DPLLIP2_BASE	0x83f84000
# define IMX51_DPLLIP2_SIZE		0x4000
#define IMX51_DPLLIP3_BASE	0x83f88000
# define IMX51_DPLLIP3_SIZE		0x4000
#define IMX51_AHBMAX_BASE	0x83f94000
# define IMX51_AHBMAX_SIZE		0x4000
#define IMX51_IIM_BASE		0x83f98000
# define IMX51_IIM_SIZE			0x4000
#define IMX51_CSU_BASE		0x83f9c000
# define IMX51_CSU_SIZE			0x4000
#define IMX51_OWIRE_BASE	0x83fa4000
# define IMX51_OWIRE_SIZE		0x4000
#define IMX51_FIRI_BASE		0x83fa8000
# define IMX51_FIRI_SIZE		0x4000
#define IMX51_ECSPI2_BASE	0x83fac000
# define IMX51_ECSPI2_SIZE		0x4000
#define IMX51_SDMA_BASE		0x83fb0000
# define IMX51_SDMA_SIZE		0x4000
#define IMX51_SCC_BASE		0x83fb4000
# define IMX51_SCC_SIZE			0x4000
#define IMX51_ROMCP_BASE	0x83fb8000
# define IMX51_ROMCP_SIZE		0x4000
#define IMX51_RTIC_BASE		0x83fbc000
# define IMX51_RTIC_SIZE		0x4000
#define IMX51_CSPI_BASE		0x83fc0000
# define IMX51_CSPI_SIZE		0x4000
#define IMX51_I2C2_BASE		0x83fc4000
# define IMX51_I2C2_SIZE		0x4000
#define IMX51_I2C1_BASE		0x83fc8000
# define IMX51_I2C1_SIZE		0x4000
#define IMX51_SSI1_BASE		0x83fcc000
# define IMX51_SSI1_SIZE		0x4000
#define IMX51_AUDMUX_BASE	0x83fd0000
# define IMX51_AUDMUX_SIZE		0x4000
#define IMX51_EMI_BASE		0x83fd8000
# define IMX51_EMI_SIZE			0x4000
#define IMX51_PATA_PIO_BASE	0x83fe0000
# define IMX51_PATA_PIO_SIZE		0x4000
#define IMX51_SIM_BASE		0x83fe4000
# define IMX51_SIM_SIZE			0x4000
#define IMX51_SSI3_BASE		0x83fe8000
# define IMX51_SSI3_SIZE		0x4000
#define IMX51_FEC_BASE		0x83fec000
# define IMX51_FEC_SIZE			0x4000
#define IMX51_TVE_BASE		0x83ff0000
# define IMX51_TVE_SIZE			0x4000
#define IMX51_VPU_BASE		0x83ff4000
# define IMX51_VPU_SIZE			0x4000
#define IMX51_SAHARA_BASE	0x83ff8000
# define IMX51_SAHARA_SIZE		0x4000

#define IMX51_CSD0DDR_BASE	0x90000000
# define IMX51_CSD0DDR_SIZE		0x10000000
#define IMX51_CSD1DDR_BASE	0xa0000000
# define IMX51_CSD1DDR_SIZE		0x10000000
#define IMX51_CS0_FLASH_BASE	0xb0000000
# define IMX51_CS0_FLASH_SIZE		0x08000000
#define IMX51_CS1_FLASH_BASE	0xb8000000
# define IMX51_CS1_FLASH_SIZE		0x08000000
#define IMX51_CS2_FLASH_BASE	0xc0000000
# define IMX51_CS2_FLASH_SIZE		0x08000000
#define IMX51_CS3_FLASH_BASE	0xc8000000
# define IMX51_CS3_FLASH_SIZE		0x04000000
#define IMX51_CS4_SRAM_BASE	0xcc000000
# define IMX51_CS4_SRAM_SIZE		0x02000000
#define IMX51_CS5_SRAM_BASE	0xcefe0000
# define IMX51_CS5_SRAM_SIZE		0x00010000
#define IMX51_NAND_FLASH_BASE	0xcfff0000
# define IMX51_NAND_FLASH_SIZE		0x00010000
#define IMX51_GPU2D_BASE	0xd0000000
# define IMX51_GPU2D_SIZE		0x10000000

#define IMX51_TZIC_BASE		0xe0000000
#define IMX51_TZIC_BASE_VADDR	0xf0000000
# define IMX51_TZIC_SIZE		0x1000
# define IMX51_TZIC_INTNUM		128


#define IMX51_DDR_BASE		IMX51_CSD0DDR_BASE
#define IMX51_CLOCK_FREQ	200000000	/* 200MHz */

#endif /* _ARM_IMX_IMX51REG_H_ */
